; Scrip del programa de FreeCommander

Include "HjGlobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
Include "HjHelp.jsh" ; Help Topic Constants
Include "common.jsm" ; message file
Include "FreeCommander.jsh" ; variables globales de FreeCommander
Include "FreeCommander.jsm" ; mensajes de FreeCommander

const
   FC_RUTA = 2, ; 1= indica la ruta en el cambio de evento, 2= indica la ruta en el cambio de panel (TAB), 0 = no indica la ruta
   FC_VELOCIDADDISPLAYBRAILLE = 3000,  ; Velocidad de visualizacin del display braille
   FC_COMILLAS = "\34"

Void Function AutoStartEvent ()
	if (nPrimeraEjecucion == 0) then
		let nPrimeraEjecucion = 1
		SayMessage(ot_message, FCM_start)
		BrailleMessage (FCM_start, 0, FC_VELOCIDADDISPLAYBRAILLE)
	endIf ; DefaultFirstTime == 0
EndFunction

Script Ruta ()
	ruta(0)
EndScript

Script Ruta2 ()
	ruta(1)
EndScript

void function Ruta(Int nVer)

var
	string sCadena,
	int x,
	int nVersion,
	String cTitulo,
	Int nPosicion

	let cTitulo = GetWindowTextEx (GetAppMainWindow(GetCurrentWindow()), False, False)
	let nPosicion = StringContains(cTitulo, " - ")
	let x = GetCursorCol ()
	let nVersion = GetProgramVersion(GetAppFilePath())
	if x < 300 then
		if nVersion == 2009 then
			Let sCadena = "1 " + GetWindowTextEx (GetPriorWindow(GetFocus()), False, False)
		Else
			if nVer == 0 then
				if nPosicion == 0 then
					Let sCadena = "1 " + cTitulo
				else
				Let sCadena = "1 " + StringLeft(cTitulo, nPosicion)
				endif
			else
Let sCadena = "1 " + GetWindowTextEx (GetParent(GetParent(GetFocus())), False, False)
			endif
		endif
	else
		if nVersion == 2009 then
			Let sCadena = "2 " + GetWindowTextEx (GetPriorWindow(GetFocus()), False, False)
		Else
			if nVer == 0 then
				if nPosicion == 0 then
					Let sCadena = "2 " + cTitulo
				else
				Let sCadena = "2 " + StringLeft(cTitulo, nPosicion)
				endif
			else
				Let sCadena = "2 " + GetWindowTextEx (GetParent(GetParent(GetFocus())), False, False)
			endif
		endif
	endif
	SayMessage(ot_message, sCadena)
	BrailleMessage (sCadena, 0, FC_VELOCIDADDISPLAYBRAILLE)

EndFunction

Script Tab ()
var
	int TheTypeCode,
	string sClass
If (InHomeRowMode()) then
	PerformScript UtilityMoveToNextWindow ()
	Return
EndIf
SayCurrentScriptKeyLabel ()
if UserBufferIsActive() then
	If MoveToControlType(s_next,wt_link) then
	 	SayLine()
 	endIf
 	return
EndIf
;If is Virtual Pc Cursur, suppress echo of highlighted Text:
Let nLastSelectUnitTime = (GetTickCount()*IsVirtualPCCursor())
TabKey ()
; Si se indica la ruta en el cambio de panel
if FC_RUTA == 2 then
	let sClass = GetWindowClass (GetFocus ())
	let TheTypeCode = getObjectTypeCode()
	if TheTypeCode == WT_LISTVIEW || TheTypeCode == WT_LISTBOXITEM then
		if sClass == "TfcDirView" || sClass == "TfcDragDropFileListView" then
			delay(1)
			ruta(0)
		endif
	endif
endif
If IsVirtualPcCursor()
&& !IsJavaWindow(GetCurrentWindow()) then
	NotifyIfContextHelp()
EndIf
EndScript

Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
	HANDLE FocusedObjectID,
	HANDLE AppMainObjectID,
	HANDLE TopLevelObjectID,
	HANDLE RealObjectID,
	handle RealWindow,
	string RealWindowName,
	handle AppWindow,
	int TheTypeCode,
	string sClass
let RealWindow = GetRealWindow (FocusWindow)
let RealWindowName = GetWindowName (RealWindow)
let AppWindow = GetAppMainWindow (FocusWindow)
let GlobalFocusWindow = FocusWindow
let FocusedObjectID = navGetFocusObjectID ()
let AppMainObjectID = navGetAppMainObjectID (FocusedObjectID, FocusWindow)
let TopLevelObjectID = navGetTopLevelObjectID (FocusedObjectID, FocusWindow)
let RealObjectID = navGetRealObjectID (FocusedObjectID, FocusWindow)
if (IsWinFormsWindow(FocusWindow)) then
	FocusChangedEventWinforms(FocusWindow, PrevWindow)
elif IsJavaWindow(FocusWindow) then
	JavaFocusChangedEvent (FocusWindow, PrevWindow)
else
	ProcessSayAppWindowOnFocusChange(AppWindow,FocusWindow)
	ProcessSayRealWindowOnFocusChange(AppWindow,RealWindow,RealWindowName,FocusWindow)
	ProcessSayFocusWindowOnFocusChange(RealWindowName,FocusWindow)
endIf
;now set all the global variables for next time.
let GlobalPrevReal = RealWindow
let GlobalPrevRealName = RealWindowName
let GlobalPrevApp = AppWindow
let GlobalPrevFocus = FocusWindow
Let GlobalWasHjDialog = InHjDialog ()
let g_PrevAppMainObjectID = AppMainObjectID
let g_PrevTopLevelObjectID = TopLevelObjectID
let g_PrevRealObjectID = RealObjectID
let g_PrevFocusedObjectID = FocusedObjectID
;Si se indica la ruta en el cambio de evento
if FC_RUTA == 1 then
	let sClass = GetWindowClass (GetFocus ())
	let TheTypeCode = getObjectTypeCode()
	if TheTypeCode == WT_LISTVIEW || TheTypeCode == WT_LISTBOXITEM then
		if sClass == "TfcDirView" || sClass == "TfcDragDropFileListView" then
			ruta(0)
		endif
	endif
endif
EndFunction

Script ScreenSensitiveHelp ()
	Var
		Int nVersion,
		String cAyuda
	let nVersion = GetProgramVersion(GetAppFilePath())
	;Teclas para el FreeCommander
	; si el buffer de usuario est activo lo cierra
	If UserBufferIsActive() Then
		UserBufferDeactivate()
	EndIf
	; limpia el buffer de usuario
	UserBufferClear ()
	let cAyuda = ""
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + FCM_Hhelp
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + FCM_Hconsejos
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + FCM_HTeclasRapidas
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + FCM_Hruta
	let cAyuda = cAyuda + "\13\10"
	if !(nVersion == 2009) then
		let cAyuda = cAyuda + FCM_Hruta2
		let cAyuda = cAyuda + "\13\10"
	endif
	let cAyuda = cAyuda + "\13\10"
	let cAyuda = cAyuda + FCM_hSalirBuffer
	let cAyuda = cAyuda + "\13\10"
	PlaySound(FindJAWSSoundFile ("ascend.wav"))
	pause()
	SayMessage(OT_USER_BUFFER, cAyuda)
EndScript

